package com.suryatejareddy.rootworld.canteen;

/**
 * Created by surya on 19/04/17.
 */

import android.content.Context;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v4.widget.SwipeRefreshLayout;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.ByteArrayBuffer;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import static android.content.Context.MODE_PRIVATE;

public class OneFragment extends Fragment {

    List<String> mobileArray = new ArrayList<String>();
    View v;
    SwipeRefreshLayout mSwipeRefreshLayout;
    ListView listView;

    public OneFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        v = inflater.inflate(R.layout.fragment_one, container, false);

        listView = (ListView) v.findViewById(R.id.mobile_list);

        SharedPreferences settings = getContext().getSharedPreferences("data", MODE_PRIVATE);
        String value = settings.getString("MBA", "");

        if (value == null) {
            new back().execute();
        } else {
            try {
                update(value);
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }


        mSwipeRefreshLayout = (SwipeRefreshLayout) v.findViewById(R.id.activity_main_swipe_refresh_layout);

        mSwipeRefreshLayout.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                if (isNetworkAvailable()) {
                    new back().execute();
                } else {
                    Toast.makeText(getContext().getApplicationContext(), "No Internet Connection", Toast.LENGTH_SHORT).show();
                    mSwipeRefreshLayout.setRefreshing(false);
                }
            }
        });
        return v;
    }


    public void update(String s) throws JSONException {
        JSONObject jsonObject = new JSONObject(s);
        JSONArray jsonArray = new JSONArray(jsonObject.getString("name"));
        JSONArray jsonArray1 = new JSONArray(jsonObject.getString("cost"));
        String s1 = jsonObject.getString("last_update");
        mobileArray.clear();
        for (int i = 0; i < jsonArray.length(); i++) {
            mobileArray.add(jsonArray.getString(i) + " (" + jsonArray1.getString(i) + ")");
        }
        ArrayAdapter adapter = new ArrayAdapter<String>(getContext().getApplicationContext(), R.layout.activity_listview, mobileArray);
        listView.setAdapter(adapter);
        Toast.makeText(getContext().getApplicationContext(), "IT : " + s1, Toast.LENGTH_SHORT).show();
    }

    private boolean isNetworkAvailable() {
        ConnectivityManager connMgr = (ConnectivityManager) getActivity()
                .getSystemService(Context.CONNECTIVITY_SERVICE);

        NetworkInfo networkInfo = connMgr.getActiveNetworkInfo();

        if (networkInfo != null && networkInfo.isConnected()) {
            return true;
        } else {
            return false;
        }
    }

    class back extends AsyncTask<Void, Void, Void> {
        public String user, pass, role, res = "-1";


        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);
            try {
                update(res);
            } catch (JSONException e) {
                e.printStackTrace();
            }
            mSwipeRefreshLayout.setRefreshing(false);
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected Void doInBackground(Void... voids) {
            // Create a new HttpClient and Post Header
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost httppost = new HttpPost("http://suryatejareddy.com/canteen/load");

            try {
                // Add your data
                List nameValuePairs = new ArrayList(2);
                nameValuePairs.add(new BasicNameValuePair("id", "MBA"));
                httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

                // Execute HTTP Post Request
                HttpResponse response = httpclient.execute(httppost);

                InputStream is = response.getEntity().getContent();
                BufferedInputStream bis = new BufferedInputStream(is);
                ByteArrayBuffer baf = new ByteArrayBuffer(20);

                int current = 0;

                while ((current = bis.read()) != -1) {
                    baf.append((byte) current);
                }

			/* Convert the Bytes read to a String. */
                String text = new String(baf.toByteArray());
                SharedPreferences settings = getContext().getSharedPreferences("data", MODE_PRIVATE);

                // Writing data to SharedPreferences
                SharedPreferences.Editor editor = settings.edit();
                editor.putString("MBA", text);
                editor.commit();
                res = text;


            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            } catch (ClientProtocolException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }
    }
}
